/*
 * Project name:
     R2R DAC on PortB
 * Copyright:
     (c) Mikroelektronika, 2010.
 * Revision History:
     20101020:
       - initial release;
       - 20101020 - Ranko Rankovic;
 * Description:
     This example makes samples of cosine and transfer it to R2R DAC which
     produces 50Hz signal
 * Test configuration:
     MCU:             ac:PIC16F887
     dev.board:       ac:EasyPICv6
     Oscillator:      HS, 08.0000 MHz
     Ext. Modules:    ac:R2R_DAC_Extra_Board
     SW:              ac:mikroC_PRO_for_PIC_v4.15

 * NOTE:
     - Connect R2R DAC Board on PortB
*/

     

char sample;
char array[61];
char cnt;

void main() {

  ANSEL  = 0;                                                 // Configure AN pins as digital I/O
  ANSELH = 0;
  C1ON_bit = 0;                                               // Disable comparators
  C2ON_bit = 0;
  PORTB = 0;                                                  // Initialize PORTB
  TRISB = 0;                                                  // Configure PORTB as output
  cnt = 0;
  
  for (sample = 0; sample <= 60; sample++) {                  // 61 sample from 0 to pi
    array[sample] = (255l * (1000 + cosE3(cnt)))/2000;        // Making samples
    cnt = cnt + 3;                                            // 3*60=180
  }

  while(1) {

    for (sample = 0; sample <= 60; sample++) {                // Samples from 0 to pi
      PORTB = array[sample];
      Delay_us(167);                                          // This delay is calculated in order to make the signal with 50Hz frequency
                                                              // This is the formula for calculating delay:
                                                              // Delay = 1/(Freq*120)
                                                              // For 50Hz  Delay is 1/(50*120) = 166.67us
    }
         
    for (sample = 59; sample > 0; sample--) {                 // Samples from pi to 2pi
      PORTB = array[sample];
      Delay_us(167);
    }
  }
}