/*
 * Project name:
     R2R DAC on PortB
 * Copyright:
     (c) Mikroelektronika, 2010.
 * Revision History:
     20101020:
       - initial release;
       - 20101020 - Ranko Rankovic;
 * Description:
     This example makes samples of cosine and transfer it to R2R DAC which
     produces 50Hz signal
 * Test configuration:
     MCU:             ac:dsPIC30F4013
     Dev.Board:       ac:EASYdsPIC6
     Oscillator:      XT, 10.000MHz
     Ext. Modules:    ac:R2R_DAC_Extra_Board

     SW:              ac:mikroC_PRO_for_dsPIC30-33_and_PIC24_v4.10

 * NOTE:
     - Connect R2R DAC Board on PortB
*/


char sample;
char array[61];
char cnt;

void main() {

  ADPCFG = 0xFFFF;                                            // Configure AN pins as digital I/O
  PORTB = 0;                                                  // Initialize PORTB
  TRISB = 0;                                                  // Configure PORTB as output
  cnt = 0;

  for (sample = 0; sample <= 60; sample++) {                  // 61 sample from 0 to pi
    array[sample] = (255l * (1000 + cosE3(cnt)))/2000;        // Making samples
    cnt = cnt + 3;                                            // 3*60=180
  }

  while(1) {

    for (sample = 0; sample <= 60; sample++) {                // Samples from 0 to pi
      PORTB = array[sample];
      Delay_us(160);                                          // This delay is calculated in order to make the signal with 50Hz frequency
                                                              // This is the formula for calculating delay:
                                                              // Delay = 1/(Freq*125)
                                                              // For 50Hz  Delay is 1/(50*125) = 150us
    }

    for (sample = 59; sample > 0; sample--) {                 // Samples from pi to 2pi
      PORTB = array[sample];
      Delay_us(160);
    }
  }
}